// flags for ui windows
int windowFlags = UI::WindowFlags::NoCollapse | 
                  UI::WindowFlags::AlwaysAutoResize | 
                  UI::WindowFlags::NoDocking | 
                  UI::WindowFlags::MenuBar;
[Setting hidden]
uint32 clicks = 0;

[Setting hidden]
uint64 medals = 0;
[Setting hidden] 
uint32 pps = 0;

[Setting hidden]
uint16 mpc = 0;
[Setting hidden]
uint32 drifts = 0;
[Setting hidden]
uint32 costDrifts = 10;

[Setting hidden]
uint16 freewheels = 0;
[Setting hidden]
uint16 turbos = 0;
[Setting hidden]
uint16 sturbos = 0;
[Setting hidden]
uint16 reactors = 0;
[Setting hidden]
uint16 sreactor = 0;

[Setting hidden]
uint16 costFreewheels = 15;
[Setting hidden]
uint16 costTurbos = 50;
[Setting hidden]
uint16 costSturbos = 250;
[Setting hidden]
uint16 costReactors = 1000;
[Setting hidden]
uint16 costSreactor = 5000;


Medals@ medalObject;

bool Updatemedals(){
   sleep(1000);
   //print(tostring(freewheels*1 + turbos*2 + sturbos*5 + reactors*10 + sreactor * 25));
   pps = freewheels*1 + turbos*2 + sturbos*5 + reactors*10 + sreactor * 25;
   medals += pps;
   return true;
}

void reset(){
   clicks = 0;
   medals = 0;
   pps = 0;
   mpc = 0;
   drifts = 0;
   costDrifts = 10;
   freewheels = 0;
   turbos = 0;
   sturbos = 0;
   reactors = 0;
   sreactor = 0;
   costDrifts = 10;
   costFreewheels = 15;
   costTurbos = 50;
   costSturbos = 250;
   costReactors = 1000;
   costSreactor = 5000;
   resetStats = false;
}



void Main()
{
   print("Maniaclicker started clicking... concerning!");

   @medalObject = Medals();

   while(true){
      Updatemedals();
      if(resetStats){
         reset();
      }
   }

}

void RenderMenu(){

   CGameCtnApp@ app = GetApp();
   if(UI::MenuItem("\\$77f" + Icons::Kenney::Pointer + "\\$z" + " Maniaclicker")){
      print("Even after incredible clicking effort, no medal was received");
      windowVisible = !windowVisible;
   }

}

void Render(){
   if(windowVisible && !useClickerWindowOnly){
      UI::Begin("MANIACLICKER", windowFlags);

      auto dl = UI::GetWindowDrawList();
      vec2 cursorPos = UI::GetWindowPos() + UI::GetCursorPos();
      //UI::Dummy(len);
      

      if(UI::BeginTable("main", 3, UI::TableFlags::Borders | UI::TableFlags::SizingStretchSame)){
         


         UI::TableNextRow();
            UI::TableSetColumnIndex(0);
            UI::Text("MANIACLICKER");

            UI::TableSetColumnIndex(1);
            UI::Text(tostring(medals) + " Medals");

            UI::TableSetColumnIndex(2);
            UI::Text(tostring(pps) + " Medals/s");


         UI::TableNextRow();
            UI::TableSetColumnIndex(0);
            UI::Text("clicks: " + clicks);
            UI::TableSetColumnIndex(1);
            if(medalObject !is null){
               if(pps >= 1000000){
                  UI::Image(medalObject.ui_atMedal);
               }else if(pps >= 1000){
                  UI::Image(medalObject.ui_goldMedal);
               }else if(pps >= 100){
                  UI::Image(medalObject.ui_silverMedal);
               }else if(pps >= 25){
                  UI::Image(medalObject.ui_bronzeMedal);
               }else {
                  UI::Image(medalObject.ui_noMedal);
               }

               if(UI::IsItemClicked()){
                  mpc = 1 + 1*drifts**1.3;
                  medals += mpc;
                  clicks++;
               }

            }else{
               print("AT wasnt loaded");
            }
         


         UI::EndTable();
      }

      UI::Separator();

      if(UI::BeginTable("##powerups", 3, UI::TableFlags::Borders)){
         

         UI::TableNextRow();
         UI::TableSetColumnIndex(0);
            UI::Text("Drifts: " + tostring(drifts));
         UI::TableSetColumnIndex(1);

         UI::BeginDisabled(medals < costDrifts);
            if(UI::Button("COST: " + tostring(costDrifts))){
               medals -= costDrifts;
               drifts++;
               costDrifts = costDrifts ** 1.2;
            }
         UI::EndDisabled();


         UI::TableSetColumnIndex(2);
         UI::Text("Drifts increase the Medals per click amount\nCurrent Mpc: " + tostring(1 + 1*drifts**1.3));

         

         UI::TableNextRow();
         UI::TableSetColumnIndex(0);
            UI::Text("Freewheel: " + tostring(freewheels));
         UI::TableSetColumnIndex(1);
         UI::BeginDisabled(medals < costFreewheels);
         if(UI::Button("COST: " + tostring(costFreewheels))){
            medals -= costFreewheels;
            freewheels++;
            costFreewheels *= 1.4;
         }
         UI::EndDisabled();
         UI::TableSetColumnIndex(2);
            UI::Text("Increases Medals/s by 1");

         
         UI::TableNextRow();
         UI::TableSetColumnIndex(0);
            UI::Text("Turbo: " + tostring(turbos));
         UI::TableSetColumnIndex(1);
         UI::BeginDisabled(medals < costTurbos);
         if(UI::Button("COST: " + tostring(costTurbos))){  
            medals -= costTurbos;
            turbos++;
            costTurbos *= 1.6;
         } 
         UI::EndDisabled();
         UI::TableSetColumnIndex(2);
            UI::Text("Increases Medals/s by 2");


         UI::TableNextRow();
         UI::TableSetColumnIndex(0);
            UI::Text("Super Turbo: " + tostring(sturbos));
         UI::TableSetColumnIndex(1);
         UI::BeginDisabled(medals < costSturbos);
         if(UI::Button("COST: " + tostring(costSturbos))){
            medals -= costSturbos;
            sturbos++;
            costSturbos *= 1.8;
         } 

         UI::EndDisabled();
         UI::TableSetColumnIndex(2);
            UI::Text("Increases Medals/s by 5");


         UI::TableNextRow();
         UI::TableSetColumnIndex(0);
            UI::Text("Reactor: " + tostring(reactors));
         UI::TableSetColumnIndex(1);
         UI::BeginDisabled(medals < costReactors);
         if(UI::Button("COST: " + tostring(costReactors))){
            medals -= costReactors;
            reactors++;
            costReactors *= 1.8;
         }
         UI::EndDisabled();
         UI::TableSetColumnIndex(2);
            UI::Text("Increases Medals/s by 10");


         UI::TableNextRow();
         UI::TableSetColumnIndex(0);
            UI::Text("Super Reactor: " + tostring(sreactor));
         UI::TableSetColumnIndex(1);
         UI::BeginDisabled(medals < costSreactor);
         if(UI::Button("COST: " + tostring(costSreactor))){
            medals -= costSreactor;
            sreactor++;
            costSreactor *= 1.8;
         }
         UI::EndDisabled();
         UI::TableSetColumnIndex(2);
            UI::Text("Increases Medals/s by 25");

         UI::EndTable();
      }

      UI::End();

   }else if (windowVisible){
      UI::Begin("MANIACLICKER", UI::WindowFlags::AlwaysAutoResize);
      if(medalObject !is null){
               if(pps >= 1000000){
                  UI::Image(medalObject.ui_atMedal);
               }else if(pps >= 1000){
                  UI::Image(medalObject.ui_goldMedal);
               }else if(pps >= 100){
                  UI::Image(medalObject.ui_silverMedal);
               }else if(pps >= 25){
                  UI::Image(medalObject.ui_bronzeMedal);
               }else {
                  UI::Image(medalObject.ui_noMedal);
               }

               if(UI::IsItemClicked()){
                  mpc = 1 + 1*drifts**1.3;
                  medals += mpc;
                  clicks++;
               }

      }else{
         print("AT wasnt loaded");
      }
      UI::End();
   }

}